unit Unit1;

interface

uses Windows, SysUtils, Classes, Controls, Forms, Dialogs, StdCtrls,
  ComCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    OpenDialog1: TOpenDialog;
    GroupBox1: TGroupBox;
    Edit1: TEdit;
    Edit2: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    ProgressBar1: TProgressBar;
    Edit3: TEdit;
    Label5: TLabel;
    procedure Button1Click(Sender: TObject);
  private
  public
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
  ReadBuf:array of byte;
  InFile,Outfile:cardinal;
  ReadBufSize,BytesRead,ReadTotal,BytesWritten,Fb,FE,CutLen, LastDelta:cardinal;
begin
 if opendialog1.Execute then begin
  button1.Enabled:=false;

  FB:=strtoint(edit1.Text); //   ( )
  FE:=strtoint(edit2.Text); //  

  CutLen:=FE-FB+1;
  if CutLen<1048576 then ReadBufSize:=CutLen else ReadBufSize:=1048576; //        1 
  setlength(ReadBuf,ReadBufSize);
  ProgressBar1.Max:=CutLen div ReadBufSize;
  LastDelta:=CutLen-(cardinal(ProgressBar1.Max)*ReadBufSize);
  

   InFile:=CreateFile(Pchar(OpenDialog1.FileName), //  
          GENERIC_READ,FILE_SHARE_READ,nil,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
   SetFilePointer(InFile,FB-1,nil,FILE_BEGIN);  //    ,    
   Outfile:=CreateFile(Pchar(edit3.Text),GENERIC_READ+GENERIC_WRITE,FILE_SHARE_READ,nil,
           CREATE_ALWAYS,0,0);
   if Outfile=INVALID_HANDLE_VALUE then begin
    MessageBox(form1.Handle,'   ', '',mb_ok);
    button1.Enabled:=true;
    Exit;
   end;

  try
   ReadTotal:=0;
   repeat begin
    ReadFile(InFile,ReadBuf[0],ReadBufSize,BytesRead,nil);
    ReadTotal:=ReadTotal+BytesRead;
    WriteFile(Outfile,ReadBuf[0],BytesRead,BytesWritten,nil);
    if ReadTotal+LastDelta=CutLen then ReadBufSize:=LastDelta;
    ProgressBar1.StepIt;
   end until ReadTotal=CutLen;

  finally
   SetEndOfFile(Outfile);
   closehandle(Outfile);
   closehandle(InFile);
  end;
   ProgressBar1.Max:=0;
   ProgressBar1.StepIt;
   button1.Enabled:=true;
 end;
end;

end.

